/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.sunspotworld;

import java.io.IOException;
import java.io.InputStream;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;

/**
 *
 * @author toboh
 */
public class LastFMConnector {

    private static final int INACTIVE = 0;
    private static final int CONNECTING = 1;
    private static final int COMPLETED = 2;
    private static final int IOERROR = 3;
    private static final int PROTOCOLERROR = 4;
    
    private static int GETstatus = INACTIVE;
    private static int POSTstatus = INACTIVE;

    
public static String getLastFMRestXML(String query, 
            String authStr) throws IOException {
        HttpConnection conn = null;
        InputStream in = null;
        StringBuffer result = new StringBuffer();
        int len = 0;
        long starttime = 0;
        
        if (query == "") return("");
        
        try {
            GETstatus = CONNECTING;
            starttime = System.currentTimeMillis();
            conn = (HttpConnection) Connector.open(query);
            conn.setRequestMethod(HttpConnection.GET);
            conn.setRequestProperty("Connection", "close");
            // conn.setRequestProperty("Authorization", "Basic " + authStr);

            // Getting the InputStream will open the connection
            // and read the HTTP headers. They are stored until
            // requested.
            in = conn.openInputStream();
            
            System.out.println("Time for HTTP connection set up: "
                    + (System.currentTimeMillis() - starttime) + " ms");
            
            // Get the ContentType
            // asd.setStatus(AppStatusDisplay.DOWNLOADING);
            String type = conn.getType();
            
            // Get the length and process the data
            len = (int) conn.getLength();
            if (len > 0) {
                byte[] data = new byte[len];
                int actual = in.read(data);
                result.append(new String(data, 0, actual));
            } else {
                int ch;
                while ((ch = in.read()) != -1) {
                    result.append((char) ch);
                }                
            }
            GETstatus = COMPLETED;
        } catch (IOException ex) {
            GETstatus = IOERROR;
            ex.printStackTrace();
        } finally {
            if (in != null) in.close();
            if (conn != null) conn.close();
        }
        
        if (GETstatus != COMPLETED)
            System.out.println("Retrieval failed");
        System.out.println("Total time to retrieve page " +
                "(including connection set up): " +
                (System.currentTimeMillis() - starttime) + " ms");
        System.out.flush();
        
        String val = result.toString();
        return val;
    }        

    public static String retrieveUserTasteometerComparation(String user1,String user2, 
            String authStr) throws IOException {
            return LastFMConnector.getLastFMRestXML("http://ws.audioscrobbler.com/2.0/?" +
                    "method=tasteometer.compare&type1=user&type2=user&" +
                    "value1=" + user1 + "&value2=" + user2 +
                    "&api_key=000000",authStr); // please notice that the API key has been replaced by a dummy one
    }        


    
    public static String retrieveUserFavoriteArtistXML(String user, 
            String authStr) throws IOException {
            return LastFMConnector.getLastFMRestXML("http://ws.audioscrobbler.com/2.0/" +
                    "?method=user.getweeklyartistchart&user=" +
                    user + "&api_key=00000",authStr);// please notice that the API key has been replaced by a dummy one
    }        

    // Parse the XML blob obtained from the HTTP GET 
    // and extract the status
    public static String parseFirstArtist(String response) {        
        int start, end;
        String intermed;
        String finalStr = null;
        
        if (response == null) return null;
        start = response.indexOf("<artist rank=\"1\">");
        end = response.indexOf("</artist>");
        if ((start != -1) && (end != -1)) {
            intermed = response.substring(start + 6, end);
        } else {
            return null;
        }

        if (intermed == null) return null;
        start = intermed.indexOf("<name>");
        end = intermed.indexOf("</name>");
        if ((start != -1) && (end != -1)) {
            finalStr = intermed.substring(start + 6, end);
        } else {
            return null;
        }
        
        
        return finalStr;
    }


        // Parse the XML blob obtained from the HTTP GET 
    // and extract the status
    public static double parseTasteometerValue(String response) {        
        int start, end;
        String intermed;
        String finalStr = null;
        
        if (response == null) return 0;
        start = response.indexOf("score>");
        end = response.indexOf("</score>");
        if ((start != -1) && (end != -1)) {
            intermed = response.substring(start + 6, end);
        } else {
            return 0;
        }

        return Double.parseDouble(intermed);
        
    }

    
    // Return directly the first favorit artist
    public static String returnFirstArtist(String user) throws IOException{        
        return  LastFMConnector.parseFirstArtist(  LastFMConnector.retrieveUserFavoriteArtistXML(user, "test")  ); 
    }

    // Return directly the tasteometerValue
    public static double returntasteometerValue(String user1, String user2) throws IOException{        
        return  LastFMConnector.parseTasteometerValue(  LastFMConnector.retrieveUserTasteometerComparation(user1, user2, "test") ); 
    }
    
    
}
