/*
 * Copyright (c) 2007 Sun Microsystems, Inc.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

package org.sunspotworld;


/**
 * Packet types for Telemetry app
 * 
 * @author Ron Goldman<br>
 * Date: January 15, 2007, revised: August 1, 2007
 */
public interface PacketTypes {

    
    // ToDo: sort data types
    
    /* Timeout times */
    public static final int PACKET_TIMEOUT  = 250; // 0.25 seconds (kind of big, change it afterwards
    
    public static final String RSSI_PORT = "254"; // 
    public static final String TEST_PORT = "69"; // 
    public static final String DB_BRCAST_PORT = "67";
    
    public static final byte UserIDTAG = 22; // 
    
    // Command & reply codes for data packets
    
    /** Client command to send location information. */
    public static final byte LOCATE_INFORMATION_ID  = 1;    // sent by fixed hotspot 
    public static final byte BRCST_TO_BE_SENSED  = 2;    // 
    public static final byte REPLY_TO_BROADCAST  = 3;    // 
    public static final byte ACK_TO_REPLY  = 4;    //    // to indicate location
    
    public static final byte RSSI_PACKET  = 7;    //    // to indicate location

}