/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.sunspotworld;

import com.sun.spot.io.j2me.radiogram.Radiogram;

import com.sun.spot.io.j2me.radiogram.RadiogramConnection;
import com.sun.spot.io.j2me.radiostream.RadiostreamConnection;
import com.sun.spot.peripheral.NoRouteException;
import com.sun.spot.peripheral.TimeoutException;
import com.sun.spot.service.IService;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Calendar;
import java.util.Date;
import javax.microedition.io.Connector;
import javax.microedition.io.Datagram;
import javax.microedition.io.DatagramConnection;
import org.sunspotworld.demo.util.PacketHandler;
import org.sunspotworld.demo.util.PacketReceiver;

/**
 *
 * @author toboh
 */

// ToDo
// - keep alive
// - proximity sensing
// - elapsed time
// - high level and low level packet answer


public class SocialHandshake 
        implements PacketHandler,  PacketTypes, IService {

    public static final String serverAlias = "tcarlyle";
    public static final String clientAlias = "kasperkopp";
    
    // no ENUMS for the sunpot =(
    // state definition
    public static final int IDLE = 0;
    public static final int REPLYING_TO_BROADCAST = 1;
    public static final int WAITING_ACK = 2;
    public static final int SENDING_ACK = 3;
    public static final int ACK_RECEIVED = 4;
    public static final int WAITING_TLS_START = 5;
    public static final int STARTING_TLS = 6;
    public static final int ACK_SENT = 7; 
    public static final int HANDSHAKE = 8; 
    
    public static final int APPLICATION_TIMEOUT  = 2000; // 2 seconds
    
    private int port;
    private String destMac;


    private String originMac;

    
    
    private RadiostreamConnection hostConn;

    private int state; 
    private int status = STOPPED;
    
    private Thread thread = null;
    private String handshakeName = "";
    
    
    private DataInputStream dis = null;
    private DataOutputStream dos = null;
    
    private long communicationTime = 0;
    private int proximityAverage = 0;
    private int proximitySamples = 0;

    private RadiogramConnection RSSIconnection= null;
    private PacketReceiver RSSIRcvr = null;
    // and their answer is needed in less then APPLICATION_TIMEOUT
    
    private String timestamp = null;
    private String myLastFMid = null;
    private String targetLastFMid = null;
    private double tasteContext = 0;
    
    private StartApplication father;
    
    
        public SocialHandshake(String destMac, String originMac,RadiostreamConnection hostConn, boolean server,StartApplication m,String targetLastFMId) {
        
        this.destMac = destMac;
        this.originMac = originMac;
        this.hostConn = hostConn;
        this.father = m;
        hostConn.setTimeout(PACKET_TIMEOUT); 

        
        Calendar cal = Calendar.getInstance();
        long now = System.currentTimeMillis(); // in order to add 2 days just add + 172800000
        cal.setTime(new Date(now));
        this.timestamp = cal.get(Calendar.YEAR) + "-" +
                        (1 + cal.get(Calendar.MONTH)) + "-" +
                        cal.get(Calendar.DAY_OF_MONTH) + " " +
                        cal.get(Calendar.HOUR_OF_DAY) + ":" +
                        cal.get(Calendar.MINUTE) + ":" +
                        cal.get(Calendar.SECOND);

        
        // the port should be set when the connection is created outside 
        // before the social handshake is created
        
        try {
                dis = (DataInputStream)hostConn.openDataInputStream();
                dos = (DataOutputStream)hostConn.openDataOutputStream();
                port = hostConn.getLocalPort(); //  

        } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
        }
        
        if(server){
            state = REPLYING_TO_BROADCAST;
            this.myLastFMid = serverAlias;
            // todo: add the tls, keep alive and other handlers
        }
        else{
            state = SENDING_ACK;
            // todo: add the tls, keep alive and other handlers
            this.targetLastFMid = targetLastFMId;
            this.myLastFMid = clientAlias;
        }
        
        handshakeName = "HS with " + destMac + " at port " + port;
        
        this.start();
        
    }

    public SocialHandshake(String destMac, String originMac,RadiostreamConnection hostConn, boolean server,StartApplication m) {
        
        this( destMac,  originMac, hostConn, server,m, ""); 
    }

        
    
        /**
     * The main transmit loop.
     */
    private void mainHandShakeLoop() {
        status = RUNNING;
        System.out.println("Started to run");
        while (status == RUNNING && thread == Thread.currentThread()) {
            switch(state){
                // first case
                case REPLYING_TO_BROADCAST:

                String answer;
                // send the reply to broadcast on the broadcast port
                // Ill open another connection and send the information about
                // this port
                System.out.println("Trying to reply to the broadcast");
                
                try{
                    DatagramConnection dgConnection = (DatagramConnection) Connector.open("radiogram://" + destMac + ":37");
                    // Then, we ask for a datagram with the maximum size allowed
                    Datagram dg = dgConnection.newDatagram(dgConnection.getMaximumLength());
                    dg.reset();
                    dg.writeByte(REPLY_TO_BROADCAST);
                    dg.writeByte(port);
                    dg.writeByte(UserIDTAG);
                    dg.writeUTF(myLastFMid);
                    dgConnection.send(dg);
                    dgConnection.close();
                }
                catch(IOException ex) {
                    System.out.println("Could not open radiogram connection");
                    ex.printStackTrace();
                    this.stop();
                    return;
                }
                
                System.out.println("Broadcast reply sent");
                
                // now I should receive the ack already in the radiostream
                try{
                    answer = dis.readUTF();
                    if(answer.equalsIgnoreCase("ACK")){
                        System.out.println("Ack succefully received");
                        
                       if( dis.readByte() != UserIDTAG){
                            System.out.println("It was supposed to receive an ID tag but it didnt");
                        }
                        else{
                            this.targetLastFMid = dis.readUTF();
                        }

                        
                    }
                    else
                        System.out.println("WTF: " + answer);
                }
                catch(TimeoutException ex){
                    System.out.println(ex.getMessage());
                    // retry
                    state = REPLYING_TO_BROADCAST;
                }
                catch(IOException ex){
                    System.out.println(ex.getMessage());
                    // retry
                    this.stop();
                    return;
                }
                state = ACK_RECEIVED;
                System.out.println("We are connected");

                break;
                // third case
                case ACK_RECEIVED:
                    // toDo code
                    //System.out.println("We are connected");
                    //this.stop();
                    
                    communicationTime = System.currentTimeMillis();
                    try {

                        RSSIconnection = (RadiogramConnection) Connector.open("radiogram://" + destMac + ":" +RSSI_PORT);
                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }
                    RSSIRcvr = new PacketReceiver(RSSIconnection);        // set up thread to receive & dispatch commands
                    RSSIRcvr.setServiceName("RSSI Receiver is on!");

                    RSSIRcvr.registerHandler(this, RSSI_PACKET);
                    RSSIRcvr.start();
                    
                    // no Lastfm connection in this test
                    /*
                    try {
                        tasteContext = LastFMConnector.returntasteometerValue(this.myLastFMid, this.targetLastFMid);
                    } catch (IOException ex) {
                        System.out.println("Shit expection trying to get the lastfm data");
                        ex.printStackTrace();
                    }
                    */
                    

                    state = HANDSHAKE;
                break;

                
                // forth case
                case SENDING_ACK:

                try{
                    dos.writeUTF("ACK");
                    dos.writeByte(UserIDTAG);
                    dos.writeUTF(myLastFMid);

                    dos.flush();
                }
                catch (NoRouteException e) {
                    System.out.println ("No route exception" + e.getMessage());
                    // retry? Todo: confirm if I should really retry
                    state = SENDING_ACK;
                }
                catch (IOException e) {
                    System.out.println ("IO exception" + e.getMessage());
                    // retry? Todo: confirm if I should really retry
                    state = SENDING_ACK;
                    this.stop();
                    return;
                }

                // ToDo: maybe try to get other exception        
                System.out.println("Ack supposed to be sent");
                state = ACK_SENT;                    
                break;

                // fith case
                case ACK_SENT:
                    // toDo code
                    //System.out.println("ACK SENT We are connected!");
                    //this.stop();
                    communicationTime = System.currentTimeMillis();
                    try {

                        RSSIconnection = (RadiogramConnection) Connector.open("radiogram://" + destMac + ":" +RSSI_PORT);
                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }
                    RSSIRcvr = new PacketReceiver(RSSIconnection);        // set up thread to receive & dispatch commands
                    RSSIRcvr.setServiceName("RSSI Receiver is on!");

                    RSSIRcvr.registerHandler(this, RSSI_PACKET);
                    RSSIRcvr.start();

                    // no Lastfm connection in this test
                    /*
                    
                   try {
                        tasteContext = LastFMConnector.returntasteometerValue(this.myLastFMid, this.targetLastFMid);
                    } catch (IOException ex) {
                        System.out.println("Shit expection trying to get the lastfm data");
                        ex.printStackTrace();
                    }
                    */
                    
                    state = HANDSHAKE; 
                break;

                // fith case
                case HANDSHAKE:
            
                // toDo code
                //Will periodically check if connection is on and send RSSI datagrams;
                 
                // send RSSI packet
                try{
                    // Then, we ask for a datagram with the maximum size allowed
                    Datagram dg = RSSIconnection.newDatagram(RSSIconnection.getMaximumLength());
                    dg.reset();
                    dg.writeByte(RSSI_PACKET);
                    RSSIconnection.send(dg);
                    
                }
                catch(IOException ex) {
                    System.out.println("Could not send RSSI packet");
                    ex.printStackTrace();
                    this.stop();
                    return;
                }

                // keep alive
                
                try{
                    dos.writeUTF("PING");
                    dos.flush();
                    System.out.println ("Ping Sent. By the way my id is " +
                           this.myLastFMid + " and his id is " + this.targetLastFMid
                           + " and our tasteometer value is " + tasteContext);
                    int n= dis.available();
                    if(n >0)
                       dis.skip(n);
                }
                // ToDo: No exception is being throwed if the connection is broken but the
                // guy is still reacheble
                catch (NoRouteException e) {
                    System.out.println ("Connection is finished: " + e.getMessage());
                    // retry? Todo: confirm if I should really retry
                    this.stop();
                    return;
                }
                catch (IOException e) {
                    System.out.println ("IO exception, ill abort: " + e.getMessage());
                    // retry? Todo: confirm if I should really retry
                    this.stop();
                    return;
                }

                
                
                // sleep    
                try {
                    this.thread.sleep(APPLICATION_TIMEOUT);
                } catch (InterruptedException ex) {
                    ex.printStackTrace();
                }
                
                    
                    
                break;

                
                
            }
            
        }
        if (thread == Thread.currentThread()) {
            status = STOPPED;
        }
    }

    
    

    public boolean start() {
          if (status == STOPPED || status == STOPPING) {
            status = STARTING;
            thread = new Thread() {
                public void run() {
                    mainHandShakeLoop();
                }
            };
            thread.setPriority(Thread.MAX_PRIORITY - 2);
            thread.start();
            System.out.println("Starting handshake: " + handshakeName);
        }
        return true;

        
    }

    public boolean stop() {
       if (status != STOPPED) {
            status = STOPPING;
            try {
                dis.close();
                dos.close();
                hostConn.close();
                RSSIRcvr.stop();
                RSSIconnection.close();
                communicationTime = (System.currentTimeMillis() - communicationTime)/1000; //milisec to sec
                
                proximityAverage = proximityAverage/proximitySamples;
                System.out.println("The handshake lasted " + communicationTime + "and with a " +
                        "proximity average of" + proximityAverage);
                this.father.addInDb(destMac,communicationTime,proximityAverage,timestamp);
                this.father.removeHandshakeFromHash(destMac);
                
            }
            catch (Exception ex) {
            //closeConnection();
                System.out.println("problem closing the connections or streams: " + ex.getMessage());
                return false;
            }    
            System.out.println("Stopping handshake: " + handshakeName);
        }
        
        return true;
    }

    public boolean pause() {
        return stop();
    }

    public boolean resume() {
        return start();
    }

    public int getStatus() {
        return status;
    }

    public boolean isRunning() {
        return status == RUNNING;
    }

    public String getServiceName() {
        return handshakeName;
    }

    public void setServiceName(String arg0) {
        if (arg0 != null)
            handshakeName = arg0;
    }

    public boolean getEnabled() {
        return false;
    }

    public void setEnabled(boolean arg0) {
        // ignore
    }

  

    // getters and setters
    public String getDestMac() {
        return destMac;
    }

    // for the distance measuring
    public void handlePacket(byte type, Radiogram pkt) {
    
        int signalStrength;
        try {
            switch (type) {
                case RSSI_PACKET:
                    signalStrength = pkt.getRssi();
                    System.out.println("RSSI packt received with power equal to "
                            + signalStrength);
                    proximityAverage = proximityAverage + signalStrength;
                    proximitySamples ++;  
                    break;
            }
        } catch (Exception ex) {
            //closeConnection();
            System.out.println("Exception in Packet Receipt: " + ex.getMessage() );
        }
    
    }
    

}
