/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package trustcalculator;

import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 *
 * @author toboh
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    private static final String DATABASE_URL = "jdbc:mysql://localhost:3306/";
    private static final String DATABASE_NAME = "Test";
    private static final String DATABASE_USER = "root";
    private static final String DATABASE_PASSWORD = "";
    private static final String JDBC_DRIVER = "com.mysql.jdbc.Driver";

    
    public static final String DATA_TABLE_NAME_2CB8 = "trust2CB8";
    public static final String DATA_TABLE_NAME_2D1E = "trust2D1E";

    // 1 week as 10 minutes
    private static final int RECENT_MAX = 30*24*60*60; //30 days  //40*60; // 40 min old
    private static final int PAST_MAX = 365*24*60*60; //365 days //3*60*60; // 520 minutes = almost 9 hours

    
    
    public static void main(String[] args) {
    
         class MyDataRow{
    
            public int privateTrust;
            public int publicTrust;
            public int professTrust;

            public String place;

            public Timestamp time;

            public MyDataRow(){

            }
    
        }

        class SimpleDate{
    
            public int day;
            public int month;

            public SimpleDate(){

            }
    
        }

         
         class Calculater{

            Statement stmt = null;
            java.sql.Connection dbCon = null;

            ArrayList myList = new ArrayList();
            ResultSet rs = null;

            
            public void FetchData(){

                try {
                    Class.forName(JDBC_DRIVER);

                    // Define URL of database server for
                    String url = DATABASE_URL + DATABASE_NAME;

                    // Get a connection to the database for given user/password
                    dbCon = DriverManager.getConnection(url, DATABASE_USER,
                            DATABASE_PASSWORD);

                    // Display URL and connection information
                    System.out.println("URL: " + url);
                    System.out.println("Connection: " + dbCon);
                } catch (Exception e) {
                    System.err.println("setUp caught " + e);
                    System.err.println("Make sure that mySQL is installed properly \n" +
                            "and has a Test database accessible via the \n" +
                            "default administrator settings on localhost:3306\n");

                }

                try{
                    // Display all results
                    stmt = dbCon.createStatement();
                    rs = stmt.executeQuery("SELECT * " +
                            "from " + DATA_TABLE_NAME_2D1E + 
                            " ORDER BY timestamp");
                    System.out.println("\t location \t privatetrust \t publictrust \t proftrust \t timestamp");

                    while (rs.next()) {
                        MyDataRow rw = new MyDataRow();
                        rw.place = rs.getString("location");
                        rw.privateTrust = rs.getInt("privatetrust");
                        rw.publicTrust = rs.getInt("publictrust");
                        rw.professTrust = rs.getInt("proftrust");
                        rw.time = rs.getTimestamp("timestamp");
                        System.out.println("\t " + rw.place + "\t" + rw.privateTrust + "\t   " +rw.publicTrust
                                + "\t" + rw.professTrust + "\t" + rw.time);
                        myList.add(rw);
                    }                                    
                    
                    
                } catch (Exception e) {
                    System.err.println("Caught " + e + " in analyzeData()");
                }
             
             
                    
            }
            
            public void GetTrustValue(int month, int day, double trust[]){
                
                int nrecent =0;
                int npast =0;
                int nold =0;
                double[] avgrecent = {0.0,0.0,0.0};
                double[] avgpast =  {0.0,0.0,0.0};
                double[] avgold =  {0.0,0.0,0.0};



                // manipulating time
                GregorianCalendar cal = new GregorianCalendar();
                cal.set(2009, month, day, 02, 00, 00);
                System.out.println("Calendar " + cal.toString());


                long now = (cal.getTimeInMillis())/1000 ;
                //long now = System.currentTimeMillis();

                // Todo: do calculation
                for (int i=0;i < myList.size(); i++ ){
                    long time = ((MyDataRow)myList.get(i)).time.getTime();
                    time = time/1000; // time in seconds
                    if ( ((now - time) > 0)  && (now - time) <= RECENT_MAX){
                        nrecent++;
                        avgrecent[0] += ((MyDataRow)myList.get(i)).professTrust;
                        avgrecent[1] += ((MyDataRow)myList.get(i)).publicTrust;
                        avgrecent[2] += ((MyDataRow)myList.get(i)).privateTrust;


                    }
                    if( ((now - time) > RECENT_MAX)  && ((now - time) <= PAST_MAX) ){
                        npast++;
                        avgpast[0] += ((MyDataRow)myList.get(i)).professTrust;
                        avgpast[1] += ((MyDataRow)myList.get(i)).publicTrust;
                        avgpast[2] += ((MyDataRow)myList.get(i)).privateTrust;



                    }
                    if( ((now - time) > PAST_MAX) ){
                        nold++;
                        avgold[0] += ((MyDataRow)myList.get(i)).professTrust;
                        avgold[1] += ((MyDataRow)myList.get(i)).publicTrust;
                        avgold[2] += ((MyDataRow)myList.get(i)).privateTrust;



                    }                
                }
                // done with the 3 sums
                //double trust[] = {0.0,0.0,0.0};

                //in order to prevent division per 0
                if (nrecent==0) nrecent=1;
                if (npast==0) npast=1;
                if (nold==0) nold=1;


                for (int i=0; i< trust.length; i++){
                    System.out.println(avgrecent[i] + " " + nrecent + " " + avgpast[i] 
                            + " " + npast + " " + avgold[i] + " " + nold);

                    trust[i] = 0.7 *(avgrecent[i]/(double)nrecent)  +  0.25 *(avgpast[i]/(double)npast) 
                            +0.05 *(avgold[i]/(double)nold);
                    System.out.println("Trust " + i +" equal to " + trust[i]);

                }

                System.out.println("To add in excel");
                for (int i=0; i< trust.length; i++){
                    System.out.print(trust[i] + "\t");
                }

            }
            
            public void GetTrustValueNOZero(int month, int day,double trust2[]){
                
                int nrecent2[] ={0,0,0};
                int npast2[] ={0,0,0};
                int nold2[] ={0,0,0};
                double[] avgrecent2 = {0.0,0.0,0.0};
                double[] avgpast2 =  {0.0,0.0,0.0};
                double[] avgold2 =  {0.0,0.0,0.0};



                // manipulating time
                GregorianCalendar cal = new GregorianCalendar();
                cal.set(2009, month, day, 02, 00, 00);
                System.out.println("Calendar " + cal.toString());


                long now = (cal.getTimeInMillis())/1000 ;
                //long now = System.currentTimeMillis();

                // Todo: do calculation
                for (int i=0;i < myList.size(); i++ ){
                    long time = ((MyDataRow)myList.get(i)).time.getTime();
                    time = time/1000; // time in seconds
                    if ( ((now - time) > 0)  && (now - time) <= RECENT_MAX){

                        // alternative logic
                        if( ((MyDataRow)myList.get(i)).professTrust != 0 ){
                            nrecent2[0]++;
                            avgrecent2[0] += ((MyDataRow)myList.get(i)).professTrust;
                        }
                        if( ((MyDataRow)myList.get(i)).publicTrust != 0 ){
                            nrecent2[1]++;
                            avgrecent2[1] += ((MyDataRow)myList.get(i)).publicTrust;
                        }
                        if( ((MyDataRow)myList.get(i)).privateTrust != 0 ){
                            nrecent2[2]++;
                            avgrecent2[2] += ((MyDataRow)myList.get(i)).privateTrust;
                        }


                    }
                    if( ((now - time) > RECENT_MAX)  && ((now - time) <= PAST_MAX) ){

                        // alternative logic
                        if( ((MyDataRow)myList.get(i)).professTrust != 0 ){
                            npast2[0]++;
                            avgpast2[0] += ((MyDataRow)myList.get(i)).professTrust;
                        }
                        if( ((MyDataRow)myList.get(i)).publicTrust != 0 ){
                            npast2[1]++;
                            avgpast2[1] += ((MyDataRow)myList.get(i)).publicTrust;
                        }
                        if( ((MyDataRow)myList.get(i)).privateTrust != 0 ){
                            npast2[2]++;
                            avgpast2[2] += ((MyDataRow)myList.get(i)).privateTrust;
                        }


                    }
                    if( ((now - time) > PAST_MAX) ){


                        // alternative logic
                        if( ((MyDataRow)myList.get(i)).professTrust != 0 ){
                            nold2[0]++;
                            avgold2[0] += ((MyDataRow)myList.get(i)).professTrust;
                        }
                        if( ((MyDataRow)myList.get(i)).publicTrust != 0 ){
                            nold2[1]++;
                            avgold2[1] += ((MyDataRow)myList.get(i)).publicTrust;
                        }
                        if( ((MyDataRow)myList.get(i)).privateTrust != 0 ){
                            nold2[2]++;
                            avgold2[2] += ((MyDataRow)myList.get(i)).privateTrust;
                        }



                    }                
                }
                // done with the 3 sums
                //double trust2[] = {0.0,0.0,0.0};


                for (int i=0; i<3;i++){
                    if (nrecent2[i]==0) nrecent2[i]=1;
                    if (npast2[i]==0) npast2[i]=1;
                    if (nold2[i]==0) nold2[i]=1;            
                }


                for (int i=0; i< trust2.length; i++){

                    trust2[i] = 0.7 *(avgrecent2[i]/(double)nrecent2[i])  +  0.25 *(avgpast2[i]/(double)npast2[i]) 
                            +0.05 *(avgold2[i]/(double)nold2[i]);

                    System.out.println("Alternative Trust is" + i +" equal to " + trust2[i]);

                }

                System.out.println("To add in excel");
                for (int i=0; i< trust2.length; i++){
                    System.out.print(trust2[i] + "\t");
                }

            }
             
             public void CalculateTrust(int month, int day, double trust1[], double trust2[]){

                // get the info from the DB
                this.FetchData();
                this.GetTrustValue(month, day, trust1);
                this.GetTrustValueNOZero(month, day, trust2);
                 
                System.out.println("Now calculating the trust");


             
             }    
             
         }
         
         // main code
         
         
         
         
         double trust2[] = {0.0,0.0,0.0};
         double trust1[] = {0.0,0.0,0.0};

         Calculater calc = new Calculater();
         calc.CalculateTrust(Calendar.MAY, 22, trust1, trust2);

         
         System.out.println("To add in excel");
         for (int i=0; i< trust2.length; i++){
              System.out.print(trust2[i] + "\t");
         }


        
    }
    
}
